<?php
/**
 * course_dev external file
 *
 * @package    local_course_dev
 * @category   external
 * @copyright  2022 talentum@andresrobin
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die;

require_once($CFG->libdir.'/externallib.php');
global $CFG;



class local_course_dev_external extends external_api {

    /**
     * reset courses
     */
     /**
     * Returns description of method parameters
     * @return external_function_parameters
     */
    public static function reset_parameters() {
        return new external_function_parameters(
            array(
                // 'courseid' => new external_value(PARAM_RAW,VALUE_OPTIONAL, 'The item id to operate on'),
            )    
        );
    }
    /**
     * 
     * @return external_description
     */
    public static function reset_returns() {
        return new external_multiple_structure(
                new external_single_structure(
                    array(
                        'message' => new external_value(PARAM_RAW, 'reset response'),
                    ), 'message'
               )
        );
    }

    public static function reset() {
        $Messages= array();
        $settings_config = (array)get_config('local_course_dev');

        $resetCourses = $settings_config['reset_course'];

        /**
         * Falta hacer una peticion a la url
         */
        // Crear opciones de la petición HTTP
        $opciones = array(
            "http" => array(
                "header" => "Content-type: application/x-www-form-urlencoded\r\n",
                "method" => "GET",
            ),
        );
        # Preparar petición
        $contexto = stream_context_create($opciones);
        # Hacerla
        $resultado = file_get_contents($resetCourses, false, $contexto);
        if ($resultado === false) {
            $response = (object) $response;
            $response->message = 'Error haciendo petición';
            $Message[] = (array) $response;
            // var_dump($Message[0]);
            return $Message;
        }
        $response = (object) $response;
        $response->message = 'Se han reiniciado los cursos';
        $Message[] = (array) $response;
            // var_dump($Message[0]);
        return $Message;
    }

    
    /**
     * Returns description of method parameters
     * @return external_function_parameters
     */
    public static function insertRecord_parameters() {
        return new external_function_parameters(
            array(
                'courseid' => new external_value(PARAM_RAW,VALUE_OPTIONAL, 'The item id to operate on'),
            )    
        );
    }
    /**
     * 
     * @return external_description
     */
    public static function insertRecord_returns() {
        return new external_multiple_structure(
                new external_single_structure(
                    array(
                         'message' => new external_value(PARAM_RAW, 'insert response'),
                    ), 'message'
                )
        );
    }

    public static function insertRecord() {
        
        $Messages= array();
        $Message = array();
       
        $local_course_dev_external = new local_course_dev_external;

        // /** Obtener promedio de notas de usuario en toda la plataforma */
        $get_grade_point_average = $local_course_dev_external->get_grade_point_average(); //----->
        // /** Fin del indicador de Promedio de calificaciones por usuario */
        

        // /** Obtener última fecha de conexión de los estudiantes*/
        $get_last_signin = $local_course_dev_external->get_last_signin(); //----->
        // /** Fin del indicador de Estudiantes que no se han conectado*/

        
        /** Indicador cantidad de cursos que tiene matriculado un estudiante */
        // $get_quantity_courses = $local_course_dev_external->get_quantity_courses(); //------>
        /** Fin del indicador de Cantidad de cursos por intitucion*/
        

        /** Indicador Progreso de todos los cursos en la plataforma*/
        $get_global_c_progress = $local_course_dev_external->get_global_c_progress(); //----->
        /** Fin del indicador de Progreso del curso general*/




        array_push($Message, $get_grade_point_average[0]); //-----> esta funcionando
        array_push($Message, $get_last_signin[0]); // ------> esta funcionando
        array_push($Message, $get_global_c_progress[0]); //-----> esta funcionando
        // array_push($Message, $get_quantity_courses[0]); //-----> esta funcionando
        

        $Messages['messages']=$Message;
        return $Messages['messages'];
    }


/**
 * se junta el itemtype y final grade
 * y se suman todas las notas para un promedio de notas en general
 * SELECT
 * gg.userid, u.username, gg.itemid, AVG(gg.finalgrade) as finalgrade
 * FROM
 * mdl_grade_grades gg
 * INNER JOIN mdl_grade_items gi
 * ON gg.itemid = gi.id AND gi.itemtype = 'course'
 * LEFT JOIN mdl_user u
 * ON gg.userid = u.id
 * GROUP BY 1
 */

public function get_grade_point_average(){
    require('db/conection.php');
    global $DB, $CFG;

    $ErroresMsg = [];

    /** 1. Obtener id de los cursos */
    $grade_point_average_getCourses = "SELECT id FROM mdl_course WHERE id != 1";
    $grade_point_average_courses = $DB->get_records_sql($grade_point_average_getCourses);
 
         
    /** 2. obtener los items de calificacion de los cursos */
    foreach($grade_point_average_courses as $grade_point_average_cdb){
        $grade_point_average_getItemsGrades = "SELECT id FROM mdl_grade_items WHERE courseid = $grade_point_average_cdb->id AND itemtype='course'";
        $grade_point_average_itemsGrades = $DB->get_records_sql($grade_point_average_getItemsGrades);
        if(empty($grade_point_average_itemsGrades)){
            $ErroresMsg['msg'] = $ErroresMsg['msg'].'El curso no tiene notas ';
            continue;
        }else{
            /** 3. obtener la calificacion final del curso por usuario */
            $grade_point_average_getGrades = "SELECT finalgrade,userid FROM mdl_grade_grades WHERE   = 1";
            $grade_point_average_grades = $DB->get_records_sql($grade_point_average_getGrades);
 
            /** 4. Obtener el email o username del usuario para compararlo con la bd de simat */
            foreach($grade_point_average_grades as $grade_point_average_gdb){
 
                $grade_point_average_getUserGrade = "SELECT username FROM mdl_user WHERE id = $grade_point_average_gdb->userid";
                $grade_point_average_userGrade = $DB->get_records_sql($grade_point_average_getUserGrade);
                /** 5. obtener id de simat de acuerdo a su usuario e insertar el dato en la tabla de indicadores */
                foreach($grade_point_average_userGrade as $grade_point_average_ugdb){
 
                            //  $grade_point_average_userDocument = explode("_", $grade_point_average_ugdb->username);
                             
                             
                            //  if (!is_numeric($grade_point_average_userDocument[1])) {
                            //      continue;
                            //  }
                             
                     $grade_point_average_getUserIdSimat ="SELECT id FROM students WHERE keycloak_sub_id=".$grade_point_average_ugdb->username."";
                    // $grade_point_average_getUserIdSimat ="SELECT id FROM students WHERE usuario='bal-est-02'";
                    
                    if ($grade_point_average_resultUserIdSimat = $conn->query($grade_point_average_getUserIdSimat)) {

                        
                        if($grade_point_average_resultUserIdSimat->num_rows != 0){
                            while($grade_point_average_userIdSimat = $grade_point_average_resultUserIdSimat->fetch_assoc()){    

                                
                                
                                /** 6. Insertar el resultado en la tabla de indicadores */
                                $grade_point_average_getUserIfExist ="SELECT student_id FROM student_indicators WHERE indicator_id=5 AND student_id=".$grade_point_average_userIdSimat['id']."";
    
                                if ($grade_point_average_resultUserIfExist = $conn->query($grade_point_average_getUserIfExist)) {
    
                                    if($grade_point_average_resultUserIfExist->num_rows == 0){
                                        $grade_point_average_insertLastAccess = "INSERT INTO student_indicators (`student_id`, `indicator_id`, `calc_indicator`) VALUES(".$grade_point_average_userIdSimat['id'].",5,'".$grade_point_average_gdb->finalgrade."')";
                                        if ($conn->query($grade_point_average_insertLastAccess) === TRUE) {
                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 5 ok ';
                                        } else {
                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 5 error insercion ';
                                        }
                                    }
                                    else{
                                                
                                        while($grade_point_average_userIfExist = $grade_point_average_resultUserIfExist->fetch_assoc()){
                                                    
                                            if($grade_point_average_userIfExist['student_id']){
                                                        
                                                $grade_point_average_updateLastAccess = "UPDATE student_indicators SET  `calc_indicator`= '".$grade_point_average_gdb->finalgrade."' WHERE `student_id`=".$grade_point_average_userIfExist['student_id']." AND indicator_id=5";

                                                if ($conn->query($grade_point_average_updateLastAccess) === TRUE) {
                                                    $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 5 update ';
                                                } else {
                                                    $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 5 error update ';
                                                }
                                            }
                                            // else{
                                            //     $grade_point_average_insertLastAccess = "INSERT INTO student_indicators (`student_id`, `indicator_id`, `calc_indicator`) VALUES(".$grade_point_average_userIdSimat->id.",5,'".$grade_point_average_gdb->finalgrade."')";
                                            //     $grade_point_average_Messages = array();
                                            //     $grade_point_average_Message = array();
                                            //     if ($conn->query($grade_point_average_insertLastAccess) === TRUE) {
                                            //         $grade_point_average_Message['message']= "get_grade_point_average / Se inserto el indicador de Promedio de notas por curso";
                                            //     } else {
                                            //         $grade_point_average_Message['message']="get_grade_point_average / Error en la insercion";
                                            //     }
                                            // }
                                        }
                                    }  
                                }      
                            }
                        }
                                 
                    }else{
                        $ErroresMsg['msg'] = $ErroresMsg['msg'].'no student in simat ';
                    }
                }
            }
        }
    }
    // var_dump($ErroresMsg);
    // $Message['message']="get_grade_point_average / Ocurrio un error ningun curso tiene calificaciones hasta el momento";
    $ErroresMsg['msg'] = $ErroresMsg['msg'].'get_grade_point_average / Se ha completado el proceso';
    $Message['message']=$ErroresMsg['msg'];
    $Messages[]=$Message;                      
    return $Messages;
}


/**
 * Ajustes del indicador:
 * eliminar la parte de consulta del rol ya que si no existe en el simat no es estudiante
 * asi ahorra 2 consultas y ciclos
 */
public function get_last_signin(){
    require('db/conection.php');
    global $DB, $CFG;

    $ErroresMsg = [];

    /** 1. Obtener id del rol de moodle */
    /** 2. Obtener user id y enrol id para saber que usuarios son estudiantes */
    $last_signin_getMoodleUserStudent = "SELECT id,enrolid,userid FROM mdl_user_enrolments";
    $last_signin_moodleUserStudent = $DB->get_records_sql($last_signin_getMoodleUserStudent);
    foreach($last_signin_moodleUserStudent as $last_signin_musdb){
        $last_signin_enrolId = $last_signin_musdb->enrolid;
        $last_signin_userId = $last_signin_musdb->userid;
                
        /** 3. obtener el curso en donde el rol sea estudiante */
        $last_signin_getCourseRolStudent = "SELECT id FROM mdl_enrol WHERE roleid = 5";
        $last_signin_courseRolStudent = $DB->get_records_sql($last_signin_getCourseRolStudent);
                
        foreach($last_signin_courseRolStudent as $last_signin_crsdb){
            /** 4. Verificamos si es un estudiante */
            if($last_signin_enrolId == $last_signin_crsdb->id){
                /** 5. obtener el ultimo acceso del estudiante */
                $last_signin_getUserLastAccess = "SELECT lastaccess FROM mdl_user WHERE id = ".$last_signin_userId."";
                $last_signin_userLastAccess = $DB->get_records_sql($last_signin_getUserLastAccess);

                foreach($last_signin_userLastAccess as $last_signin_uladb){
                            
                    // preguntar a fabian como se colocaria el indicador ya que son estudiantes que no se han conectado en un determinado tiempo

                    if($last_signin_uladb->last_signin_lastaccess == 0){
                        /** 6. insertar el indicador en la tabla donde nunca se ha conectado */
                        // $last_signin_dateToIsert = strtotime($last_signin_uladb->lastaccess);
                        $last_signin_dateToIsertIndicator = date('d/m/Y', $last_signin_uladb->lastaccess);
                                
                        $last_signin_getUserToInsertDate = "SELECT username FROM mdl_user WHERE id = $last_signin_userId";
                        $last_signin_userToInsertDate = $DB->get_records_sql($last_signin_getUserToInsertDate);
                            
                        foreach($last_signin_userToInsertDate as $last_signin_utiddb){
                                    // $last_signin_userDocumentToInsertDate = explode("_", $last_signin_utiddb->username);
                                    
                                    // if (!is_numeric($last_signin_userDocumentToInsertDate[1])) {
                                    //     continue;
                                    // }
                            $last_signin_getUserIdSimatToInsertDate ="SELECT id FROM students WHERE keycloak_sub_id='".$last_signin_utiddb->username."'";
                            // $last_signin_getUserIdSimatToInsertDate ="SELECT id FROM students WHERE usuario='bal-est-02'";
                                    
                                    
                            if ($last_signin_resultUserIdSimatToInsertDate = $conn->query($last_signin_getUserIdSimatToInsertDate)) {
                                
                                

                                if($last_signin_resultUserIdSimatToInsertDate->num_rows != 0){

                                    while($last_signin_userIdSimatToInsertDate = $last_signin_resultUserIdSimatToInsertDate->fetch_assoc()){

                                        
                                        /** 6. Insertar el resultado en la tabla de indicadores */
                                        $last_signin_getUserIfExist ="SELECT student_id FROM student_indicators WHERE indicator_id=2 AND student_id=".$last_signin_userIdSimatToInsertDate['id']."";

                                        if ($last_signin_resultUserIfExist = $conn->query($last_signin_getUserIfExist)) {

                                            if($last_signin_resultUserIfExist->num_rows == 0){
                                                $last_signin_insertLastAccess = "INSERT INTO student_indicators (`student_id`, `indicator_id`, `calc_indicator`) VALUES(".$last_signin_userIdSimatToInsertDate['id'].",2,'".$last_signin_dateToIsertIndicator."')";

                                                if ($conn->query($last_signin_insertLastAccess) === TRUE) {
                                                    $ErroresMsg['msg'] = $ErroresMsg['msg'].' Ind: 2 ok ';
                                                    break;
                                                } else {
                                                    $ErroresMsg['msg'] = $ErroresMsg['msg'].' Ind: 2 error insert ';
                                                    break;
                                                }
                                            }
                                            else{
                                                
                                                while($last_signin_userIfExist = $last_signin_resultUserIfExist->fetch_assoc()){
                                                    
                                                    
                                                    if($last_signin_userIfExist['student_id']){
                                                        
                                                        $last_signin_updateLastAccess = "UPDATE student_indicators SET  `calc_indicator`= '".$last_signin_dateToIsertIndicator."' WHERE `student_id`=".$last_signin_userIdSimatToInsertDate['id']." AND indicator_id=2";
                                                        if ($conn->query($last_signin_updateLastAccess) === TRUE) {
                                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].' update Ind: 2 ';
                                                            break;
                                                        } else {
                                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].' Update Ind: 2 error ';
                                                            break;
                                                        }
                                                        
                                                    }
                                                    // else{
                                                    //     $last_signin_insertLastAccess = "INSERT INTO student_indicators (`student_id`, `indicator_id`, `calc_indicator`) VALUES(".$last_signin_userIdSimatToInsertDate['id'].",2,'".$last_signin_dateToIsertIndicator."')";

                                                    //     if ($conn->query($last_signin_insertLastAccess) === TRUE) {
                                                    //         // array_push($ErroresMsg, 'get_last_signin / Se inserto el indicador de Promedio de notas por curso');

                                                    //         $last_signin_Message['message']= "get_last_signin / Error en la insercion";
                                                    //     } else {
                                                    //         // array_push($ErroresMsg, 'get_last_signin / Se Actualizo el indicador de last login');

                                                    //         $last_signin_Message['message']="get_last_signin / Error en la insercion";
                                                    //     }
                                                    // }
                                                }
                                                break;
                                            }
                                                
                                                
                                        }             
                                    }
                                }else{
                                        $ErroresMsg['msg'] = $ErroresMsg['msg'].'No Encontro el usuario '.$last_signin_utiddb->username.' ';
                                }
                                                            
                            }  
                        }
                    }
                }
            }
        }
    }
    $ErroresMsg['msg'] = $ErroresMsg['msg'].'get_last_signin / Se ha completado el proceso';
    $last_signin_Message['message']=$ErroresMsg['msg'];
    $last_signin_Messages[]=$last_signin_Message;
    return $last_signin_Messages;
}

/**
 * Se debe de eliminar la lase completons y agregar las consultas
 * 
 * esta da el total de actividades
 * 
 * SELECT
 * mue.userid, COUNT(mcm.course) as actividades
 * FROM
 * mdl_user_enrolments mue
 * LEFT JOIN mdl_enrol me
 * ON mue.enrolid = me.id
 * LEFT JOIN mdl_course_modules mcm
 * ON me.courseid = mcm.course
 * GROUP BY 1
 * ####################################
 * 
 * Esta da el total de actividades completadas por usuario
 * SELECT
 * mcmc.userid, COUNT(mcmc.coursemoduleid) as completadas
 * FROM
 * mdl_course_modules_completion mcmc
 * GROUP BY 1
 * 
 */

    public static function get_global_c_progress(){
        
        global $DB, $CFG;
        require('db/conection.php');
        require_once($CFG->libdir . '/completionlib.php');
        $ErroresMsg = [];
        

        // //1. obtengo todos los cursos de la plataforma
        $courseGeneral_getCoursesCant = "SELECT * FROM mdl_course WHERE id != 1";
        $courseGeneral_courses = $DB->get_records_sql($courseGeneral_getCoursesCant);
        //variable que cuenta el progreso totoal de un estudiante
        $progress_per_student = array();
        $courseGeneral_Messages = array();
        $courseGeneral_Message = array();
        foreach($courseGeneral_courses as $courseGeneral_cdb){
            

            $courseGeneral_courseViewId = $courseGeneral_cdb->id;
            
            
            //2. obtengo el id de los usuarios para comprobar su porcentaje en el curso
            /**obtengo los id de los studiantes */
            $courseGeneral_getUserId = "SELECT ue.userid AS 'user_id' FROM mdl_user_enrolments AS ue JOIN mdl_enrol AS e WHERE e.roleid = 5 AND e.id=ue.enrolid";
            $courseGeneral_userId = $DB->get_records_sql($courseGeneral_getUserId);
            

            foreach($courseGeneral_userId as $courseGeneral_uiddb){
                
                $courseGeneral_user_Id=$courseGeneral_uiddb->user_id;
                
                
                //3. Obtengo el porcentaje de progreso del cursso

                //funcion para obtener el porcentage de progreso del curso por usuario

                        // Make sure we continue with a valid userid.
                        if (empty($courseGeneral_user_Id)) {
                            $userid = 0;
                        }

                        $completion = new \completion_info($courseGeneral_cdb);
                        
                        
                        // First, let's make sure completion is enabled.
                        // if (!$completion->is_enabled()) {
                        //     $courseGeneral_Messages[]='el cuso no esta activo para ser completo';
                    
                        //     return $courseGeneral_Messages; 
                        // }

                        // if (!$completion->is_tracked_user($courseGeneral_userId)) {
                        //     $courseGeneral_Messages[]='el usuario no tiene seguimiiento en el curso';
                    
                        //     return $courseGeneral_Messages; 
                        // }

                        // Before we check how many modules have been completed see if the course has.
                        // if ($completion->is_course_complete($courseGeneral_userId)) {
                        //     $courseGeneral_Messages[]='el usuario no tiene seguimiiento en el curso';
                    
                        //     return $courseGeneral_Messages; 
                        // }

                        // Get the number of modules that support completion.
                        $modules = $completion->get_activities();
                        $count = count($modules);
                        if (!$count) {
                            $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 9 no hay actividades ';
                            // $courseGeneral_Message['message']="Hay cursos que no tienen actividades";
                        
                            // $courseGeneral_Messages[]=$courseGeneral_Message;
                            // break;
                            // return $courseGeneral_Messages;  
                        }

                        // Get the number of modules that have been completed.
                        $completed;
                        foreach ($modules as $module) {
                            $data = $completion->get_data($module, true, $courseGeneral_user_Id);
                            $completed += $data->completionstate == 0 ? 0 : 1;
                        }
                        $progress_std = array(
                            'course_id'=>$courseGeneral_courseViewId,
                            'id'=>$courseGeneral_user_Id,
                            'progress'=>(int)($completed / $count) * 100
                        );
                        
                        array_push($progress_per_student,$progress_std);

                        
            }
        }
            //4. obtengo el id de los usuarios para comprobar su porcentaje en el curso
            /**obtengo los id de los studiantes */
            $courseGeneral_getUserId = "SELECT ue.userid AS 'user_id' FROM mdl_user_enrolments AS ue JOIN mdl_enrol AS e WHERE e.roleid = 5 AND e.id=ue.enrolid";
            $courseGeneral_userId = $DB->get_records_sql($courseGeneral_getUserId);
            
        foreach($courseGeneral_userId as $courseGeneral_uiddb){
            $courseGeneral_user_Id=$courseGeneral_uiddb->user_id;
            
            
            $cant_courses;
            $progress_count = 0;
            
            foreach($progress_per_student as  $prog){
                
                if($prog["id"] == $courseGeneral_user_Id){
                    $progress_count = $progress_count + $prog["progress"];
                }
                $cant_courses++;
            }


            //5 insercion en la bd el dato de progreso del curso
            $global_progress_getUserToInsertDate = "SELECT username FROM mdl_user WHERE id = $courseGeneral_user_Id";
            
            $global_progress_userToInsertDate = $DB->get_records_sql($global_progress_getUserToInsertDate);
            foreach($global_progress_userToInsertDate as $global_progress_utiddb){
                

                // $global_progress_userDocumentToInsertDate = explode("_", $global_progress_utiddb->username);
                
                // if (!is_numeric($global_progress_userDocumentToInsertDate[1])) {
                //     continue;
                // }


                $courseGeneral_getCourseIfExist ="SELECT id FROM students WHERE keycloak_sub_id='".$global_progress_utiddb->username."'";
                // $courseGeneral_getCourseIfExist ="SELECT id FROM students WHERE usuario='bal-est-02'";
                


                if ($courseGeneral_resultCourseIfExist = $conn->query($courseGeneral_getCourseIfExist)) {
                    
                    if($courseGeneral_resultCourseIfExist->num_rows == 0){
                        while($courseGeneral_courseIfExist = $courseGeneral_resultCourseIfExist->fetch_assoc()){ 
                            
                            $courseGeneral_insertNewCourse = "INSERT INTO student_indicators (`student_id`,`indicator_id`, `calc_indicator`) VALUES(".$courseGeneral_courseIfExist['id'].",9,'".$progress_count/$cant_courses."')";
                            if ($conn->query($courseGeneral_insertNewCourse) === TRUE) {
                                $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 9 ok ';
                            } else {
                                $$ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 9 error ';
                            }
                        }
                    }
                    else{
                        while($courseGeneral_courseIfExist = $courseGeneral_resultCourseIfExist->fetch_assoc()){  
                            $courseGeneral_getidUserIfExist ="SELECT student_id FROM student_indicators WHERE student_id=".$courseGeneral_courseIfExist['id']."";
                            if ($courseGeneral_resultidUserIfExist = $conn->query($courseGeneral_getidUserIfExist)) {
                                if($courseGeneral_resultidUserIfExist->num_rows == 1){
                                                              
                                $courseGeneral_updateNewCourse = "UPDATE student_indicators SET  `student_id`= '".$courseGeneral_courseIfExist['id']."',`calc_indicator`='".$progress_count/$cant_courses."' WHERE `student_id`=".$courseGeneral_courseIfExist['id']." AND indicator_id = 9";
                                    if ($conn->query($courseGeneral_updateNewCourse) === TRUE) {
                                        $ErroresMsg['msg'] = $ErroresMsg['msg'].'Update Ind: 9 ok ';
                                    } else {
                                        $ErroresMsg['msg'] = $ErroresMsg['msg'].'Update Ind: 9 error ';
                                    }
                                }
                                else{
                                        $courseGeneral_insertNewCourse = "INSERT INTO student_indicators (`student_id`,`indicator_id`, `calc_indicator`) VALUES(".$courseGeneral_courseIfExist['id'].",9,'".$progress_count/$cant_courses."')";
                                        if ($conn->query($courseGeneral_insertNewCourse) === TRUE) {
                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 9 ok ';
                                        } else {
                                            $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 9 error ';
                                        }
                                }  
                            }     
                        }
                    }
                }
            }
            // $courseGeneral_Message['message']="get_global_c_progress / Error en la insercion no existe usuario en moodle";
                        
            // $courseGeneral_Messages[]=$courseGeneral_Message;
            // return $courseGeneral_Messages;  
            $cant_courses = 0;
        }
    // }
        $ErroresMsg['msg'] = $ErroresMsg['msg'].'get_global_c_progress / Se ha completado el proceso';
        $courseGeneral_Message['message']=$ErroresMsg['msg'];
                        
        $courseGeneral_Messages[]=$courseGeneral_Message;
                    
        return $courseGeneral_Messages;  
    }

/**
 * se debe de hacer un conteo de cursos el indicador debe de quedar así
 * userid | indicator_id | cantidad de cursos
 *   1           6                50
 * 
 * 
 * falta hacer la sumatoria de los cursos
 */
    // public static function get_quantity_courses(){
    //     require('db/conection.php');
    //     global $DB, $CFG,$USER;

        
    //     /** 1. Obtener cursos de moodle */
    //     $courses = get_courses();
    //     foreach($courses as $course){
    //         $context = get_context_instance(CONTEXT_COURSE, $course->id);
    //         /** 2. Obtener usuarios de moodle */
    //         $usersMoodle = "SELECT id FROM mdl_user WHERE username !='guest' and username != 'admin'";
    //         $users = $DB->get_records_sql($usersMoodle);
    //         foreach($users as $user){
    //             /** 3. verificar si el usuario esta matriculado en el curso */
    //             $enrrolluser = is_enrolled($context, $user->id);
    //             if($enrrolluser){
    //                 /** si el usuario esta matriculado inserta el id del usuario y el nombre del curso en la bd simat */
                    
    //                 $courseGeneral_getCourseIfExist ="SELECT id FROM students WHERE keycloak_sub_id='".$global_progress_utiddb->username."'";
    //             // $courseGeneral_getCourseIfExist ="SELECT id FROM students WHERE usuario='bal-est-02'";
    //             if($course->fullname != 'moodle4'){
    //                 if ($courseGeneral_resultCourseIfExist = $conn->query($courseGeneral_getCourseIfExist)) {
                    
    //                     if($courseGeneral_resultCourseIfExist->num_rows == 0){
    //                         while($courseGeneral_courseIfExist = $courseGeneral_resultCourseIfExist->fetch_assoc()){ 
                                
    //                             $courseGeneral_insertNewCourse = "INSERT INTO student_indicators (`student_id`,`indicator_id`, `calc_indicator`) VALUES(".$courseGeneral_courseIfExist['id'].",6,'".$course->fullname."')";
    //                             if ($conn->query($courseGeneral_insertNewCourse) === TRUE) {
    //                                 $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 6 ok ';
    //                             } else {
    //                                 $$ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 6 error ';
    //                             }
    //                         }
    //                     }
    //                     else{
    //                         while($courseGeneral_courseIfExist = $courseGeneral_resultCourseIfExist->fetch_assoc()){  
    //                             $courseGeneral_getidUserIfExist ="SELECT student_id FROM student_indicators WHERE student_id=".$courseGeneral_courseIfExist['id']."";
    //                             if ($courseGeneral_resultidUserIfExist = $conn->query($courseGeneral_getidUserIfExist)) {
    //                                 if($courseGeneral_resultidUserIfExist->num_rows == 1){
                                                                  
    //                                 $courseGeneral_updateNewCourse = "UPDATE student_indicators SET  `student_id`= '".$courseGeneral_courseIfExist['id']."',`calc_indicator`='".$course->fullname."' WHERE `student_id`=".$courseGeneral_courseIfExist['id']." AND indicator_id = 6";
    //                                     if ($conn->query($courseGeneral_updateNewCourse) === TRUE) {
    //                                         $ErroresMsg['msg'] = $ErroresMsg['msg'].'Update Ind: 6 ok ';
    //                                     } else {
    //                                         $ErroresMsg['msg'] = $ErroresMsg['msg'].'Update Ind: 6 error ';
    //                                     }
    //                                 }
    //                                 else{
    //                                         $courseGeneral_insertNewCourse = "INSERT INTO student_indicators (`student_id`,`indicator_id`, `calc_indicator`) VALUES(".$courseGeneral_courseIfExist['id'].",6,'".$course->fullname."')";
    //                                         if ($conn->query($courseGeneral_insertNewCourse) === TRUE) {
    //                                             $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 6 ok ';
    //                                         } else {
    //                                             $ErroresMsg['msg'] = $ErroresMsg['msg'].'Ind: 6 error ';
    //                                         }
    //                                 }  
    //                             }     
    //                         }
    //                     }
    //                 }
    //                 $ErroresMsg['msg'] = $ErroresMsg['msg'].'Error: no se encontro usuario keycloak ';
                        
    //                 }
    //             }
                
    //         }
            
    //     }

    //     $ErroresMsg['msg'] = $ErroresMsg['msg'].'get_quantity_courses / Se ha completado el proceso';
    //     $courseGeneral_Message['message']=$ErroresMsg['msg'];
                        
    //     $courseGeneral_Messages[]=$courseGeneral_Message;
                    
    //     return $courseGeneral_Messages;  
    // }



}