<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Muestra el contenido de la página
 *
 * @package   local_decalogo
 * @copyright 2021 su nombre
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

require_once('../../../config.php');
require_once('../db/conection.php');
require_once($CFG->dirroot.'/user/externallib.php');



global $DB, $OUTPUT, $PAGE, $CFG, $USER;

require_login();

$isAdmin = is_siteadmin();



$PAGE->requires->js(new moodle_url($CFG->wwwroot.'/local/course_dev/js/index.js'));
$PAGE->requires->css(new moodle_url($CFG->wwwroot.'/local/course_dev/css/styles.css'));

mb_internal_encoding('UTF-8');

// Definimos nuestra página
$PAGE->set_url('/local/course_dev/pages/admin.php');
$PAGE->set_pagelayout('standard');

$settings_config = (array)get_config('local_course_dev');

/**url de reinicio de cursos */
$resetCourses = $settings_config['reset_course'];
foreach ($settings_config as $configname => $configvalue) {
    if($configname == 'test')$text_title = $configvalue;
}

if(!$isAdmin){
    $urltogo= $CFG->wwwroot.'/my/';

    echo '<script>';
    echo 'alert("No tienes permiso para acceder a los reportes");';
    echo 'window.location.href = "'.$urltogo.'"';
    echo '</script>';
    // redirect($urltogo);
}
// Determinar si es la primera vez que se accede (insertar) o 
// no es la primera vez (desplegar y actualizar).

echo $OUTPUT->header();

/**
 * Cargar estudiantes en una categoria
 */

echo html_writer::tag('hr','');
echo html_writer::start_tag('div',['class'=>"container-fluid"]);
echo html_writer::start_tag('div',['class'=>"row"]);


/**
 * 
 * Matriuclar estudiantes en la cohorte Student
 */
echo html_writer::start_tag('div',['class'=>'col-sm-6']);

echo html_writer::tag('h2',"Matricular estudiantes cohorte Students");
echo html_writer::tag('p',"Esta opcion es para matricular todos los estudiantes en una cohorte");

/**
 * Get the departments
 */
$department = "SELECT id,name FROM dtops";
$res_department= $conn->query($department);

?>
<div class="">
    <form method="post" >
        <div class="local-course-dev-form-controller-container">
            <label for="">Selecciona un departamento</label>
            <select name="departments" id="" class="form-select" onChange="selectDeparment(this);">
                <option 
                <?php if (!isset($_GET['dpto'])){?>  
                selected 
                <?php } ?> 
                disabled>
                Seleccione una departamento para cargar los estudiantes</option>
                <?php
                if ($res_department) {
                    while ($row_d = $res_department->fetch_assoc()) {
                            ?>
                            <option value="<?php echo $row_d['id'] ?>"
                            <?php if (isset($_GET['dpto'])){
                                if ($_GET['dpto'] == $row_d['id']){
                                    ?>  selected <?php
                                }
                            }?>
                            ><?php echo $row_d['name'] ?></option>
                <?php            
                    }
                }
                ?>
            </select>
        </div>
        <?php
        if (isset($_GET['dpto'])) { 
            /**
             * Get the cities
             */
            $cities = "SELECT id,name FROM towns WHERE dtop_id =".$_GET['dpto']." ";
            $res_cities = $conn->query($cities);
            ?>
            <div class="local-course-dev-form-controller-container">
                <label for="">Selecciona una ciudad</label>
                <select name="cities" id="" class="form-select" onChange="selectCity(this,<?php echo $_GET['dpto']; ?>);">
                    <option 
                    <?php if (!isset($_GET['city'])){?>  
                    selected 
                    <?php } ?> 
                    disabled>
                    Seleccione una ciudad para cargar los estudiantes</option>
                    <?php
                    if ($res_cities) {
                        while ($row_c = $res_cities->fetch_assoc()) {
                                ?>
                                <option value="<?php echo $row_c['id'] ?>"
                                <?php if (isset($_GET['city'])){
                                    if ($_GET['city'] == $row_c['id']){
                                        ?>  selected <?php
                                    }
                                }?>
                                ><?php echo $row_c['name'] ?></option>
                    <?php            
                        }
                    }
                    ?>
                </select>
            </div>
        <?php
            if (isset($_GET['city'])) { 
                /**
                 * Get the headquarters
                 */
                $headquartes = "SELECT id,name FROM headquarters WHERE town_id=".$_GET['city'];
                $res_headquarter = $conn->query($headquartes);
                ?>
                <div class="local-course-dev-form-controller-container">
                    <label for="">Selecciona una sede</label>
                    <select name="headquarters" id="" class="form-select" onChange="activeButtonCohorts()">
                        <option selected disabled>Selecciones una sede</option>
                        <?php
                        if ($res_headquarter) {
                            while ($row_h = $res_headquarter->fetch_assoc()) {
                                    ?>
                                    <option value="<?php echo $row_h['id'] ?> "><?php echo $row_h['name'] ?></option>
                        <?php            
                            }
                        }
                        ?>
                    </select>
                </div>
                <?php
            }
        }
        ?>
        <div class="local-course-dev-form-controller-container">
            <button type="submit" name="buttonLoadStudentsCohort" id="buttonLoadStudentsCohort" disabled class="local-course-dev-btn btn btn-success" >Cargar estudiantes</button>
        </div>
    </form>
</div>



<?php
echo html_writer::end_tag('div');

/**
 * 
 * Reiniciar courses
 */
echo html_writer::start_tag('div',['class'=>'col-sm-6']);

echo html_writer::tag('h2',"Reiniciar cursos");
echo html_writer::tag('p',"Esta opcion es para reiniciar todos los cursos a su estado inicial solo con contenidos");

/**
 * Falta agregar la funcion onclick qu llama el index.js para ejecutar la peticion con ajax y que de una respuesta
 */
echo html_writer::start_tag('div', array('class'=>'local-course-dev-form-controller-container'));
echo html_writer::start_tag('button', array('value'=>'test','class'=>'local-course-dev-btn btn btn-info','id'=>'btn-reset'));
echo 'Reiniciar Cursos';
echo html_writer::end_tag('button');
echo html_writer::end_tag('div');
echo html_writer::start_tag('span',['class'=>'d-block text-secondary-emphasis mt-2']);
echo 'url de reinicio de cursos '.$resetCourses;
echo html_writer::end_tag('span');



?>

<?php
echo html_writer::end_tag('div');
echo html_writer::end_tag('div');
echo html_writer::end_tag('div');


/**
 * 
 * Funciones para la matriculación en la cohorte
 */

if(isset($_POST['buttonLoadStudentsCohort'])) {
    /**
     * get headquarters_has_grade_has_group
     */
    $usersSimatHeadquarters = "SELECT id FROM headquarters_has_grade_has_group WHERE headquarters_id=".$_POST['headquarters'];

    $res_usersSimatHeadquarters = $conn->query($usersSimatHeadquarters);

    $users_before = array();

    if ($res_usersSimatHeadquarters) {
        while ($row_uSH = $res_usersSimatHeadquarters->fetch_assoc()) {
            /**
            * get headquarters_has_grade_has_group_simat
            */
            $usersSimatHeadquarters_uSimat = "SELECT student_id FROM headquarters_has_grade_has_group_has_user WHERE headquarters_has_grade_has_group_id =".$row_uSH['id'];

            $res_usersSimatHeadquarters_uSimat = $conn->query($usersSimatHeadquarters_uSimat);
            if ($res_usersSimatHeadquarters_uSimat) {
                while ($row_uSHUS = $res_usersSimatHeadquarters_uSimat->fetch_assoc()) {
                    /**
                     * get users
                     */
                    $users = "SELECT 
                    S.id,S.number_document as idnumber, 
                    ST.simat_id, ST.id as student_id, 
                    ST.keycloak_sub_id as username,
                    CONVERT(S.name USING utf8) as name, 
                    CONVERT(S.second_name USING utf8) as second_name, 
                    CONVERT(S.last_name USING utf8) as last_name, 
                    CONVERT(S.second_surname USING utf8) as second_surname,
                    INST.name as institution 
                    FROM simat AS S 
                    JOIN students as ST on ST.simat_id = S.id 
                    INNER JOIN headquarters_has_grade_has_group_has_user AS HGGS ON ST.id = HGGS.student_id
                    INNER JOIN headquarters_has_grade_has_group AS HGG ON HGGS.headquarters_has_grade_has_group_id = HGG.id
                    INNER JOIN headquarters AS H ON HGG.headquarters_id = H.id
                    INNER JOIN institutions AS INST ON H.institution_id = INST.id
                    WHERE ST.id=".$row_uSHUS['student_id']."";

                    

                    $res_users = $conn->query($users);


                    if ($res_users) {
                        while ($row_users = $res_users->fetch_assoc()) {
                            
                            // createUsers($row_users['name'],$row_users['second_name'],$row_users['last_name'],$row_users['second_surname']);
                        
                            $user_before = array(
                                'id' => $row_users['student_id'],
                                'name' => $row_users['name'],
                                'second_name' => $row_users['second_name'],
                                'last_name' => $row_users['last_name'],
                                'second_surname' => $row_users['second_surname'],
                                'username'=> $row_users['username'],
                                'idnumber' =>$row_users['idnumber'],
                                'institution' =>$row_users['institution']
                            );
                            array_push($users_before,$user_before);


                        }
                    }
                }
            }

        }
        createUsersAllCohort($users_before, $conn);
    }
    
}
$matricohorte=0;

/** matricular los estudiantes en la cohorte */
function createUsersAllCohort($users, $conn){
    global $DB, $OUTPUT, $PAGE, $CFG, $USER;
    $countedBad = 0;
    $countedUpdated= 0;
    $countedSuccess = 0;

    $sql1 = "SELECT u.id,u.username,u.email FROM mdl_user AS u ";
    $usersmoodle = $DB->get_records_sql($sql1); 
    $actualsUsernames = array ();
    $actualsEmails = array ();
    $lastID;
    foreach($usersmoodle as $um){
        $username_m = $um->username;
        $lastID = $um->id;
        $emails_m = $um->email;
        array_push($actualsUsernames, $username_m);
        array_push($actualsEmails, $emails_m);
            
    }
     /**
     * create token to load users
     */
    $token = $DB->get_record_select("external_tokens", "externalserviceid in (select externalserviceid from {external_services_functions} where functionname = 'core_user_create_users') and userid in (select value from {config} where name = 'siteadmins')",null,'token',MUST_EXIST)->token; // premade admin user token
    $url = $CFG->wwwroot . "/webservice/rest/server.php?wstoken=$token&wsfunction=core_user_create_users&moodlewsrestformat=json";
    /**
     * create token to update users
     */
    $token_update = $DB->get_record_select("external_tokens", "externalserviceid in (select externalserviceid from {external_services_functions} where functionname = 'core_user_update_users') and userid in (select value from {config} where name = 'siteadmins')",null,'token',MUST_EXIST)->token; // premade admin user token
    $url_update = $CFG->wwwroot . "/webservice/rest/server.php?wstoken=$token_update&wsfunction=core_user_update_users&moodlewsrestformat=json";

    

    foreach ($users as $user) {
        //datos del usuario a insertar o actualizar
        $username = strtolower($user['username']);
        $first_name = strtolower($user['name'].' '.$user['second_name']);
        $last_name = mb_strtolower($user['last_name'],'UTF-8').' '.mb_strtolower($user['second_surname'],'UTF-8');
        $email = $username.'@localhost.com';

        //compruebo si el usuario existe
        $userExist = "SELECT u.username,u.id FROM mdl_user AS u WHERE u.username = '".$username."'";
        $userExistResult = $DB->get_records_sql($userExist); 

        if(empty($userExistResult)){
           //obtengo los datos del ususario para la creación
                // $users = array($user);
        
                $params = array(
                    'users[0][createpassword]' => 1, 
                    'users[0][username]' => $username,
                    'users[0][firstname]'=> $first_name,
                    'users[0][lastname]'=> $last_name,
                    'users[0][email]'=> $email,
                    'users[0][idnumber]'=>$user['idnumber'],
                    'users[0][institution]' =>$user['institution'],
                    'users[0][auth]' => 'oidc'
                );

                $curl = new curl();
                $resp = $curl->post($url, $params);
                $clone = json_decode($resp);

                /**
                 * obtengo la cohorte students
                 */
                $cohort = 'SELECT id FROM `mdl_cohort` WHERE name="Students"';
                $res_cohort = $DB->get_records_sql($cohort); 

                $cohortId = 0;
                foreach($res_cohort as $cohortStudents){
        
                    $cohortId = $cohortStudents->id;
                    break 1;
                }
                
                $countedSuccess+=1;
                /**
                * Enroll usesr into a cohort
                */
                // $sqlUserExist = "SELECT id FROM `mdl_user` WHERE username='".substr($clone->debuginfo,25)."'";
                // $idUser = $DB->get_records_sql($sqlUserExist); 
                // foreach($idUser as $user){
                enroll_cohort($clone[0]->id, $cohortId); //descomentar esta opcion cuando se tenga los cursos para poder ejecutar la matriculacion
                // }
        }else{
            //comprueba si el usuario ya existe
            foreach($userExistResult as $userNameResult){

                        
                //comprueba si el usuario ya existe
                if($userNameResult){
                    /**
                    * Actualizar el usuario
                    */
                    $paramsupdate = array(
                        'users[0][id]' => $userNameResult->id,
                        'users[0][username]' => $username, 
                        'users[0][firstname]'=> $first_name,
                        'users[0][lastname]'=> $last_name,
                        'users[0][email]'=> $email,
                        'users[0][idnumber]'=>$user['idnumber'],
                        'users[0][institution]' =>$user['institution']
                    );
                    
                    $curl_upd = new curl();
                    $resp_upd = $curl_upd->post($url_update, $paramsupdate);
                    $clone_upd = json_decode($resp_upd);

                    if($clone_upd->warnings){
                        $countedBad+=1;
                    }else{
                        $countedUpdated+=1;
                    }
                

                }
            }
        }
        

        /** quito el forzar cambio de contraseña */
        $userForcePasswordChange = "UPDATE mdl_user_preferences SET value='0' where name='auth_forcepasswordchange' and value='1'";
        $res_userForcePasswordChange = $DB->execute($userForcePasswordChange); 
        
    }
    if($matricohorte!=0){
        \core\notification::Warning('Esta sede ya esta matriculada en la cohorte');
    }
    \core\notification::Success('Total usuarios creados y matriculados: '. $countedSuccess);
    \core\notification::Warning('Total usuarios actualizados: '. $countedUpdated);
    \core\notification::Error('Total usuarios con errores: '. $countedBad);

}

function enroll_cohort($userid, $cohort) {
    global $DB;
    /**
     * Inserto el usuario como participante de la cohorte
     */
    $dataObj = new stdClass();
    $dataObj->cohortid = $cohort;
    $dataObj->userid  = $userid;
    try{
        $enrollCohort = $DB->insert_record('cohort_members',$dataObj);
    }
    catch(\Exception $e){
        $matricohorte=1;
    }
    
}
?>
<?php




echo $OUTPUT->footer();


